module Coder where

import Instruction

codingError = error . ("coding error: " ++)


coding ((address, machineCodes, ins, comment):is) =
    codingAddress address ++ ":\t" ++
    codingMachineCodes machineCodes ++ "\t" ++
    codingMnemonic (ins, comment) ++ "\n"  ++ 
    if is == []
    then
        codingAddress (address + length machineCodes) ++ ":" ++ "\t\t\t" ++codingComment "generated by gmc4cc (terus)" ++ "\n"
    else
        coding is
coding [] = "" 

codingMnemonic (ins, comment) =
    case ins of
      i@(Operand0 _) -> "\t" ++ show i ++ codingComment comment
      i@(OperandInt1 _ _) -> "\t" ++ show i ++ codingComment comment
      i@(OperandString1 _ _) -> "\t" ++ show i ++ codingComment comment
      i@(Label _) -> show i ++ codingComment comment
      i -> "\t" ++ show i ++ codingComment comment

codingAddress = hexString 2

codingMachineCodes = unwords . map hexChar

hexChar i | i < 16 = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"] !! i
hexChar i = codingError ("invalid integer " ++ show i)

hexString 0 0 = ""
hexString n 0 = "0" ++ hexString (n-1) 0
hexString n i = hexString (n - 1) (div i 16) ++ hexChar (mod i 16)


codingComment "" = ""
codingComment s = "\t\t# " ++ s

codingFxp = ("<?xml version=\"1.0\"?>\n<ArrayOfString xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" ++) . 
            (++"</ArrayOfString>\n") .
            (codingFxpInstructions 0x60) 
codingFxpInstructions n ((address, machineCodes, ins, comment):is) =
    concat (map (("  <string>"++).(++"</string>\n").hexChar) machineCodes) ++ codingFxpInstructions (n - length machineCodes) is
codingFxpInstructions n [] | n <= 0 = "" 
codingFxpInstructions n [] = "  <string>F</string>\n" ++ codingFxpInstructions (n - 1) []
